''Moon Patrol Demo By Jeff Ledger/OBC
CON

'{Hybrid Setup
_clkmode = xtal1 + pll16x
_xinfreq = 6_000_000
modepins = %011_0000

  NES0_RIGHT    = %00000000_00001000
  NES0_LEFT     = %00000000_00000100
  NES0_DOWN     = %00000000_00000010
  NES0_UP       = %00000000_00000001
  NES0_START    = %00000000_10000000
  NES0_SELECT   = %00000000_10000000
  NES0_B        = %00000000_00100000
  NES0_A        = %00000000_00100000

'}

{Proto/Demo Board Setup
  _clkmode = xtal1 + pll16x                            '
  _xinfreq = 5_000_000
  modepins = %001_0101

  NES0_RIGHT    = %00000000_00000001
  NES0_LEFT     = %00000000_00000010
  NES0_DOWN     = %00000000_00000100
  NES0_UP       = %00000000_00001000
  NES0_START    = %00000000_00010000
  NES0_SELECT   = %00000000_00100000
  NES0_B        = %00000000_01000000
  NES0_A        = %00000000_10000000
'}

{Hydra Setup
_clkmode = xtal1 + pll8x
_xinfreq = 10_000_000
modepins = %011_0000

  NES0_RIGHT    = %00000000_00000001
  NES0_LEFT     = %00000000_00000010
  NES0_DOWN     = %00000000_00000100
  NES0_UP       = %00000000_00001000
  NES0_START    = %00000000_00010000
  NES0_SELECT   = %00000000_00100000
  NES0_B        = %00000000_01000000
  NES0_A        = %00000000_10000000
'}

PAL=%0001
NTSC=%0000
INTERLACED=%0010

x_tiles = 8 '*16=256            ' 128 bytes/line
y_tiles = 12 '*16=192
mode = 0
my_hx = 22+((mode&1)<<1)

x_pixels = x_tiles*16
y_pixels = y_tiles*16

bcnt = 128*191
clockfreq = ((_CLKMODE - XTAL1) >> 6) * _XINFREQ
_1mS  = clockfreq /     1_000 'Divisor for  1mS

  maxSprites    = 7
  maxYSZ        = 16
  maxXSZ        = 4
  spriteSZ      = maxYSZ*maxXSZ

  '' NES bit encodings for NES gamepad 0

  '' joypad serial shifter settings
  JOY_CLK = 3
  JOY_LCH = 4
  JOY_DATAOUT0 = 5
  JOY_DATAOUT1 = 6

OBJ
  tv    : "JB_TV_AMS_01"
  font  : "Font_ATARI"
  debug  : "Parallax Serial Terminal"
   
VAR
  long  frame

  byte  Shadows[16*maxYSZ*maxSprites]
  byte  shadowX[maxSprites]
  byte  shadowY[maxSprites]
  byte  ix[8],iy[8],ii[8],spritemode[maxSprites]

  word  Nes_Pad

  byte  move
  
PUB Main | i,c,x,y,lc,speed

  tv.start(@tvparams)
  frame~
  fatprint(string(" MOON PATROL DEMO BY JEFF LEDGER"),0,0)
   
  ix := 32
  iy := 140
  speed:=24

'Jeff, you forgot to set the sprite size for it to score the background initially :D
  spriteysz[0]:=8
  spritexsz[0]:=24

  repeat
    Nes_Pad := NES_Read_Gamepad
    Vsync

    Restoreshadow(0)            ' you need to restore the background before scrolling it to a new place also
    repeat y from 48 to 191
      i := @data+(y<<6)
      c := byte[ i ]
      bytemove(i,i+1,63)
      byte[i+63] := c
    
    if(Nes_Pad & NES0_RIGHT)
      if speed>0
        speed--
        ix++
        
    if(Nes_Pad & NES0_LEFT)
      if speed<40
        speed++
        ix--
                                
'    if(Nes_Pad & NES0_UP)
   
    SaveShadow(0,ix,iy)         '
          
    print(string("BUG"),ix,iy,6,-1)
'    print(string("BUG"),0,44,6,-1)

    ms(speed)            


pub MakeSprite(n,x,y,xsz,ysz) | i
  spriteXSZ[n] := xsz           ' save size properties
  spriteYSZ[n] := ysz
  repeat i from 0 to ysz        ' Q&D screen area grab to sprite table
     bytemove(@sprites[(n*spriteSZ)+(i*maxXSZ)], @data+(x>>1)+((y+i)<<6), xsz>>1)

pub CopySprite(dst,src)
  bytemove(@sprites[dst*spriteSZ],@sprites[src*spriteSZ],spriteSZ)
  spriteXSZ[dst] := spriteXSZ[src]
  spriteYSZ[dst] := spriteYSZ[src]

pub DrawSprite(n,x,y) | i
  if spriteXSZ[n] AND spriteYSZ[n]
    x &= 127                      ' wrap any X given as it may be incrementing past the right side
    repeat i from 0 to spriteYSZ[n] ' Q&D screen area write from sprite table
      if spritemode[n] & 1
        bytefill(screen(x,y+i), $11+i+(i<<4), spriteXSZ[n]>>1)
      else
        bytemove(screen(x,y+i), @sprites[(n*spriteSZ)+(i*maxXSZ)], spriteXSZ[n]>>1)                     'Changed i*maxYSZ to i*maxXSZ as that's the length per scanline of sprite


pub SaveShadow(n,x,y) | i,p
  shadowX[n] := x               ' remember the position of the shadow for later restoration
  shadowY[n] := y
  p := n*spriteSZ               ' speed things up a bit and remember sprite table address
  repeat i from 0 to spriteYSZ[n]
     bytemove(@shadows[p+(i*maxXSZ)], screen(x,y+i), spriteXSZ[n]>>1)

pub RestoreShadow(n) | i,p
  if shadowx[n] + shadowy[n]    ' another Q&D to prevent restore the first time the sprite is drawn
    p := n*spriteSZ
    repeat i from 0 to spriteYSZ[n]
       bytemove(screen(shadowX[n], shadowY[n]+i), @shadows[p+(i*maxXSZ)], spriteXSZ[n]>>1)


' full screen synchronized drawing

pub DrawSprites | i
'  RestoreScreen
  SaveShadows
  repeat i from maxSprites-1 to 0        ' update the sprites in priority - 0 = top
    DrawSprite(i,ix[i],iy[i])

pub SaveShadows | i
  repeat i from 0 to maxSprites-1        ' update the sprites
    SaveShadow(i,ix[i],iy[i])


pub RestoreScreen | i           ' part of the "draw em all, restore them all" plan for later
  repeat i from 0 to maxSprites-1
    RestoreShadow(i)


pub Collided(sprite1,sprite2)
  if ix[sprite1] => ix[sprite2] and ix[sprite1] =< ix[sprite2]+spriteXSZ[sprite2]
    if iy[sprite1] => iy[sprite2] and iy[sprite1] =< iy[sprite2]+spriteYSZ[sprite2]
      result := true


pub screen(x,y)                 ' point to the screen memory which consists of 2 pixels/byte, 64 bytes/line
  result := @data+(x>>1)+(y<<6)


PUB plot(x,y,c)
  if(x<0 or x=>x_pixels or y<0 or y=>y_pixels)
    return
  c&=15
  if(x&1)
    data[y<<6+x>>1]:=(data[y<<6+x>>1]&$f0)+c
  else
    data[y<<6+x>>1]:=(data[y<<6+x>>1]&$0f)+(c<<4)



PUB print(s,x,y,c,b)            ' s=string, x,y obvious c=colour,b=background colour -1=transparent background
  repeat while byte[s][0]
    prtchr(byte[s][0],x,y,c,b)
    s++
    x+=8

PUB prtchr(ch,x,y,c,b) | f,xx,yy
  f:=font.GetPtrToFontTable+(ch<<3)
  repeat yy from 0 to 7
    repeat xx from 0 to 7
      if(byte[f][0]&(|<(7-xx)))
        plot(x+xx,y+yy,c)
      else
        if(b<>-1)
          plot(x+xx,y+yy,b)
    f++

PUB fatprint(s,x,y)            ' s=string, x,y obvious c=colour,b=background colour -1=transparent background
  repeat while byte[s][0]
    fatprtchr(byte[s][0]-32,x,y)
    s++
    x+=4

PUB fatprtchr(ch,x,y) | f,c,yy
  f:=@fatfont[ch<<4]
  repeat yy from 0 to 7
    c:=byte[f]&$0f
    plot(x  ,y,c)
    c:=byte[f++]>>4
    plot(x+1,y,c)
    c:=byte[f]&$0f
    plot(x+2,y,c)
    c:=byte[f++]>>4
    plot(x+3,y++,c)

PUB VSync
  repeat until VSyncFlag<>1
  repeat until VSyncFlag==1

PUB ms(Period)
  if Period                                    '1 mS
    waitcnt(_1mS * Period + cnt)

PUB NES_Read_Gamepad : nes_bits        |  i
' //////////////////////////////////////////////////////////////////
' NES Game Paddle Read
' //////////////////////////////////////////////////////////////////
' reads both gamepads in parallel encodes 8-bits for each in format
' right game pad #1 [15..8] : left game pad #0 [7..0]
'
' set I/O ports to proper direction
' P3 = JOY_CLK      (4)
' P4 = JOY_SH/LDn   (5)
' P5 = JOY_DATAOUT0 (6)
' P6 = JOY_DATAOUT1 (7)
' NES Bit Encoding
'
' RIGHT  = %00000001
' LEFT   = %00000010
' DOWN   = %00000100
' UP     = %00001000
' START  = %00010000
' SELECT = %00100000
' B      = %01000000
' A      = %10000000

' step 1: set I/Os
DIRA [JOY_CLK] := 1 ' output
DIRA [JOY_LCH] := 1 ' output
DIRA [JOY_DATAOUT0] := 0 ' input
DIRA [JOY_DATAOUT1] := 0 ' input

' step 2: set clock and latch to 0
OUTA [JOY_CLK] := 0 ' JOY_CLK = 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0
'Delay(1)

' step 3: set latch to 1
OUTA [JOY_LCH] := 1 ' JOY_SH/LDn = 1
'Delay(1)

' step 4: set latch to 0
OUTA [JOY_LCH] := 0 ' JOY_SH/LDn = 0

' data is now ready to shift out, clear storage
nes_bits := 0

' step 5: read 8 bits, 1st bits are already latched and ready, simply save and clock remaining bits
repeat i from 0 to 7

 nes_bits := (nes_bits << 1)
 nes_bits := nes_bits | INA[JOY_DATAOUT0] | (INA[JOY_DATAOUT1] << 8)

 OUTA [JOY_CLK] := 1 ' JOY_CLK = 1
 'Delay(1)
 OUTA [JOY_CLK] := 0 ' JOY_CLK = 0

 'Delay(1)
' invert bits to make positive logic
nes_bits := (!nes_bits & $FFFF)




DAT

tvparams      long    0               'status
              long    1               'enable
              long    modepins        'pins ' PROTO/DEMO BOARD = %001_0101 ' HYDRA = %011_0000
              long    mode            'mode
              long    x_tiles         'hc
              long    y_tiles         'vc
              long    my_hx           'hx
VSyncFlag     long    0
nextline      long    0                        
disp_ptr      long    @data+$10
bordercolour  long    $02
              long    @palette+$10

palette       byte    $02,$07,$28,$8d,$ba,$1a,$db,$3d,$8f,$5f,$3f,$5b,$d8,$04,$02,$02

data          file    "moonpatrol.bit"  

sprites       file    "propspr.bit"
SpriteXSZ     byte     6, 6, 6, 6, 6, 6, 6
SpriteYSZ     byte     9, 9, 9, 9, 9, 9, 8



fatfont       file    "fatfont.chr"